/*
 * @Author: Chi Yao 
 * @Date: 2019-01-19 12:21:58 
 * @Last Modified by: Chi Yao
 * @Last Modified time: 2019-11-12 20:13:50
 */

const CryptoUtil = require("../utils/CryptoUtil");
const host = "api.yosmart.com";
const keys = {
    csid: process.env.CSID || "XXXXXXXXXXXXXXXXXXXXXXXX",
    cskey: process.env.CSSecKey || "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
    name: process.env.CSName || "CSName"
}


module.exports = {
    keys,
    api: {
        http: {
            url: `https://${host}`
        },
        mqtt: {
            url: `mqtt://${host}:8003`,
            user: keys.csid,
            pwd: CryptoUtil.encryptHash(keys.cskey).toLowerCase()
        }
    }
}