/*
 * @Author: Chi Yao 
 * @Date: 2019-01-19 12:21:44 
 * @Last Modified by: Chi Yao
 * @Last Modified time: 2019-02-23 09:33:39
 */
const MQTTClient = require("./Client");
var Crypto = require("../utils/CryptoUtil");

let mainClient = new MQTTClient("XXXX");
const start = function(done){
    mainClient.connect(done);
}
const stop = function(done){
    mainClient.disconnect(done);
}
const Manage = {
    addHub: (hubInfo, next) => {
        if (!hubInfo.hubId || !hubInfo.hubPwd) {
            next(new Error(900001));
        } else {
            if (hubInfo.hubPwd.length != 32) {
                hubInfo.hubPwd = Crypto.encryptHash(hubInfo.hubPwd);
            }
            hubInfo.hubPwd = hubInfo.hubPwd.toLowerCase();
            mainClient.publish("Manage.addHub", undefined, hubInfo, next);
        }
    },
    searchDevice: (hubInfo, next) => {
        if (!hubInfo.deviceId || !hubInfo.token) {
            next(new Error(900001));
        } else {
            mainClient.publish("Manage.searchDevice", hubInfo, undefined, next);
        }
    }
}
const Hub = {
    getGeneralInfo:(hubInfo,next)=>{
        if (!hubInfo.deviceId || !hubInfo.token) {
            next(new Error(900001));
        } else {
            mainClient.publish("Hub.getGeneralInfo", hubInfo, undefined, next);
        }
    }
}
const Thermostat = {
    getState:(deviceInfo,next)=>{
        if (!deviceInfo.deviceId || !deviceInfo.token) {
            next(new Error(900001));
        } else {
            mainClient.publish("Thermostat.getState", deviceInfo, undefined, next);
        }
    },
    setState:(deviceInfo,params,next)=>{
        if (!deviceInfo.deviceId || !deviceInfo.token) {
            next(new Error(900001));
        } else {
            mainClient.publish("Thermostat.setState", deviceInfo, params, next);
        }
    }
}
exports.start = start;
exports.stop = stop;
exports.Manage = Manage;
exports.Hub = Hub;
exports.Thermostat = Thermostat;