/*
 * @Author: Chi Yao 
 * @Date: 2019-01-19 12:20:47 
 * @Last Modified by: Chi Yao
 * @Last Modified time: 2019-02-23 09:49:24
 */
const MQTTApi = require("../Mqtt");
const expect = require("chai").expect;

describe("Test Add Hub In MQTT API", function () {
    this.timeout(10000);
    before(function (done) {
        MQTTApi.start(done);
    });

    after(function (done) {
        done&&done();
        // setTimeout(()=>{
        //     MQTTApi.stop();
        // },1000);
        
    });

    beforeEach(function (done) {
        // clean(mongoConnection, done);
        done&&done();
    });

    it("Should Throw Error When Hub PWD Error", function (done) {
        MQTTApi.Manage.addHub({
            hubId:"16010001",
            hubPwd:"XXXXXXXX"
        },(err,result)=>{
            expect(err.code).to.eql("020102");
            done();
        });
    });
});
describe("Test Search Lorahome Device By Hub In MQTT API", function () {
    this.timeout(10000);
    before(function (done) {
        // Noting to do
        done&&done();
    });

    after(function (done) {
        // Noting to do
        done&&done();
    });

    beforeEach(function (done) {
        // clean(mongoConnection, done);
        done&&done();
    });

    it("Should Throw Error When Hub Token Error", function (done) {
        MQTTApi.Manage.searchDevice({
            deviceId:"16010001",
            token:"XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX"
        },(err,result)=>{
            expect(err.code).to.eql("000103");
            done();
        });
    });
});
describe("Get Hub Info In Mqtt API", function () {
    this.timeout(10000);
    before(function (done) {
        // Noting to do
        done&&done();
    });

    after(function (done) {
        // Noting to do
        done&&done();
    });

    beforeEach(function (done) {
        // clean(mongoConnection, done);
        done&&done();
    });

    it("Should Get Hub Info When Hub Token Valid", function (done) {
        MQTTApi.Hub.getGeneralInfo({
            deviceId:"10100E61",
            token:"79c6cf9b-0e22-49f9-90ab-beba8e98b09d"
        },(err,result)=>{
            expect(result.data.name).to.eql("YoSmart");
            expect(err).to.eql(undefined);
            done();
        });
    });
});

describe("Thermostat  In MQTT API", function () {
    this.timeout(10000);
    before(function (done) {
        // Noting to do
        done&&done();
    });

    after(function (done) {
        // Noting to do
        done&&done();
    });

    beforeEach(function (done) {
        // clean(mongoConnection, done);
        done&&done();
    });

    it("Should Get Thermostat Info When Token Valid", function (done) {
        MQTTApi.Thermostat.getState({
            deviceId:"4007002A",
            token:"bb6af5ba-1f33-47c9-ad9b-47e1342bc216"
        },(err,result)=>{
            console.log(result);
            expect(typeof result).to.eql("object");
            expect(err).to.eql(undefined);
            done();
        });
    });
    it("Should Set Thermostat Info When Token Valid", function (done) {
        MQTTApi.Thermostat.setState({
            deviceId:"4007002A",
            token:"bb6af5ba-1f33-47c9-ad9b-47e1342bc216"
        },{
            "fan":false,
            "manual":false,
            "mode":"AUTO",
            "heatTemp":77,
            "coolTemp":88
        },(err,result)=>{
            console.log(result);
            console.log(err);
            expect(typeof result).to.eql("object");
            expect(err).to.eql(undefined);
            done();
        });
    });

    
});